<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css"
    />
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
  </head>
  <body>
    <div class="container mt-4">
      <h2>Lucky Dice Username</h2>
      <div class="form-group">
        <label for="username">User name:</label>
        <input
          type="email"
          class="form-control"
          id="user-name"
          placeholder="Enter username"
          name="username"
        />
      </div>
      <div class="form-group">
        <button
          type="button"
          class="btn btn-primary"
          onclick="onBtnShowPresentClick()"
        >
          Show Present History Table
        </button>
      </div>
      <div id="log-result" class="mt-5"></div>
      <div class="mt-5">
        <table
          id="table-present-history"
          class="table table-striped table-bordered table-hover"
        >
          <thead>
            <tr>
              <th>#Game</th>
              <th>Present</th>
            </tr>
          </thead>
          <tbody id="table-body"></tbody>
        </table>
      </div>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gEND_OF_ROW_COL = -1;
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
      const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //hàm thực thi khi nút Show Present History Table được click
      function onBtnShowPresentClick() {
        var vUserObj = {
          username: "",
        };

        //b1: thu thập dữ liệu
        thuThapDuLieu(vUserObj);
        //b2: kiểm tra thông tin
        var vCheck = kiemTraDuLieu(vUserObj);
        if (vCheck) {
          //b3: gọi api để lấy lịch sử present
          var vXmlHttpPresentHistory = new XMLHttpRequest();
          goiApiLayLsPresent(vXmlHttpPresentHistory, vUserObj);
          //b4: hiển thị dữ liệu
          vXmlHttpPresentHistory.onreadystatechange = function () {
            if (
              this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
              this.status == gREQUEST_STATUS_OK
            ) {
              hienThiDuLieu(vXmlHttpPresentHistory);
            }
          };
        }
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function thuThapDuLieu(paramUserObj) {
        var vUsernameInput = document.getElementById("user-name");
        paramUserObj.username = vUsernameInput.value.trim();
      }

      function kiemTraDuLieu(paramUserObj) {
        if (paramUserObj.username == "") {
          alert("Bạn cần nhập username");
          return false;
        }

        return true;
      }

      function goiApiLayLsPresent(paramXmlHttp, paramUserObj) {
        paramXmlHttp.open(
          "GET",
          gBASE_URL + "/prize-history?username=" + paramUserObj.username,
          true
        );
        paramXmlHttp.send();
      }

      function hienThiDuLieu(paramXmlHttp) {
        console.log(paramXmlHttp.responseText);

        var vPresentHistoryObj = JSON.parse(paramXmlHttp.responseText);
        var vPresentHistoryTBody = document.getElementById("table-body");

        vPresentHistoryTBody.innerHTML = "";

        for (var bI = 0; bI < vPresentHistoryObj.prizes.length; bI++) {
          var bNewRow = vPresentHistoryTBody.insertRow(gEND_OF_ROW_COL);
          var bGameCell = bNewRow.insertCell(0);
          var bPresentCell = bNewRow.insertCell(1);
          bGameCell.innerHTML = bI + 1;
          bPresentCell.innerHTML = vPresentHistoryObj.prizes[bI];
        }
      }
    </script>
  </body>
</html>
